(* EPITA SPE 2009/2010       *)
(* Control 1 - Novembre 2009 *)
(* question08.ml             *)

module Q = Question08

let rec make_list getN =
  function
      0 -> Q.Nil
    | n -> Q.Cons (
	{
	  Q.value = getN();
	  Q.next = make_list getN (n-1)
	}
      )

let rec print_t_list =
  function
      Q.Nil -> Format.printf " {}"
    | Q.Cons {Q.value=h;Q.next=t} ->
	Format.printf "@;{@[<b 1>@;value= %02d;@;next=" h;
	print_t_list t;
	Format.printf "@]@;}"

let main () =
  begin
    let q = new Test_frame.qSeedSizeInt 8 100 in
      q#beginParse;
      q#init;
      let l = make_list (fun _ -> q#getN) q#getSize in
	Format.printf "@[<b 0>l =";
	print_t_list l;
	Format.printf "@]@.";
	Format.printf "len l = %d@." (Q.len l);
  end

let _ = main ()
